#! /bin/sh

echo 2 2 > /mnt/flash/productinfo/AlarmInOut.txt

date

[ -d /mnt/flash/Server/lib ] && mount --bind /mnt/flash/Server/lib /usr/lib && [ -f /mnt/flash/IceLib.tar.gz ] && tar xzvf /mnt/flash/IceLib.tar.gz -C /usr/lib

[ -d /mnt/flash/Server/etc ] && mount --bind /mnt/flash/Server/etc /etc
touch /tmp/resolv.conf && ln -sf /tmp/resolv.conf /etc/resolv.conf
[ -d /mnt/flash/Server/root ] && mount --bind /mnt/flash/Server/root /root
[ -d /mnt/flash/Server/usr/sbin ] && cp -rf /usr/sbin /mnt/flash/Server/usr/ && mount --bind /mnt/flash/Server/usr/sbin /usr/sbin
[ -f /mnt/flash/logo.tgz ] && tar xzvf /mnt/flash/logo.tgz -C /mnt/flash/Server/web/browse/images/

[ -f /mnt/flash/Server/LINUX/odm.cfg ] && cp /mnt/flash/Server/LINUX/odm.cfg /mnt/flash/databak/odm.cfg
if ! diff -q /mnt/flash/databak/odm.cfg /mnt/flash/databak/odm_bak.cfg 2>/dev/null ; then
	[ -f /mnt/flash/databak/odm.cfg ] && rm /mnt/flash/databak/Version.txt && cp /mnt/flash/databak/odm.cfg /mnt/flash/databak/odm_bak.cfg
fi

echo "=================== load driver & reset sensor ==================="
export PATH=/mnt/flash/Server/tools:${PATH}
/mnt/flash/Server/driver/loadKO
himm 0x200f00d4 0x1 #GPIO 0_0
gpio_test s 1 1
gpio_test w 1 0
sleep 1
gpio_test w 1 1
> /mnt/flash/productinfo/deviceid.txt
sleep 1

echo "=================== check sensor type ==================="
#Check Sensor Type
i2c_set_clock_read_reg()
{
	# i2c_set_clock_read_reg clock_val dev_addr reg_addr reg_len data_len
	
	# 1. i2c_sensor_clock clock
	himm 0x200f0050 0x2 > /dev/null	# i2c0_scl
	himm 0x200f0054 0x2 > /dev/null	# i2c0_sda
	himm 0x2003002c $1 > /dev/null	# sensor unreset, set clk & VI
	_reg_addr=$3
	i2c_read 0x0 $2 $3 $3 $4 $5 | awk -v reg=$_reg_addr '$1 == reg {print $2}'
}
SensorType="NONE"
sensorname=mn34220
if [ "${SensorType}" = "NONE" ];then
	#check for mn34220
	REG_VAL=$(i2c_set_clock_read_reg 0x90007 0x6c 0x0212 2 1)
	[ "${REG_VAL}" = "0x1" ] && SensorType="MN34220" && sensorname=mn34220
fi
if [ "${SensorType}" = "NONE" ];then
	#check for ar0331
	REG_VAL=$(i2c_set_clock_read_reg 0xE0007 0x30 0x3000 2 2)
	[ "${REG_VAL}" = "0x2602" ] && SensorType="AR0331" && sensorname=ar0331
fi
if [ "${SensorType}" = "NONE" ];then
	#check for ov4689
	REG_VAL=$(i2c_set_clock_read_reg 0xE0007 0x6c 0x3006 2 1)
	[ "${REG_VAL}" = "0x42" ] && SensorType="OV4689" && sensorname=ov4689
fi
if [ "${SensorType}" = "NONE" ];then
	#check for imx185
	REG_VAL=$(i2c_set_clock_read_reg 0x90007 0x34 0x303a 2 1)
	[ "${REG_VAL}" = "0xc9" ] && SensorType="IMX185" && sensorname=imx185
fi
if [ "${SensorType}" = "NONE" ];then
	#check for imx178
	REG_VAL=$(i2c_set_clock_read_reg 0xF0007 0x34 0x3015 2 1)
	[ "${REG_VAL}" = "0x3c" ] && SensorType="IMX178" && sensorname=imx178
fi
# none sensor match
if [ "${SensorType}" = "NONE" ];then
	echo "Check Sensor Type Error !"
else
	echo "Got Sensor Type : ${SensorType}"
	echo -n "DEVICEID V6202IR-"${SensorType} > /mnt/flash/productinfo/deviceid.txt
	RUN_SCRIPT="./load3516a -i -sensor ${sensorname}"
	SENSOR_NAME="/usr/lib/libsns_${sensorname}.so"
fi
echo "=================== check sensor type done  ====================" 

APPS_PATH=/mnt/flash/Server
MIDSEV_PATH=$APPS_PATH/mediaserver

hi3518e_branch=
if [ "$(cat /mnt/flash/Server/LINUX/hisi_type.cfg 2>/dev/null)" = "hi3518e" ];then
	if [ -e  /mnt/flash/Server/LINUX/moto.type ];then
	        hi3518e_branch=moto
	elif [ -e  /mnt/flash/Server/LINUX/card.type ];then
	        hi3518e_branch=card
	else
		hi3518e_branch=single
	fi
else
	hi3518e_branch=
fi

if [ -f /mnt/flash/productinfo/deviceid.txt ];then
	devid=$(awk '$1 == "DEVICEID" {print $2}' /mnt/flash/productinfo/deviceid.txt)
	sensor_pixel=2M
	case ${devid} in
		V6812IR-H00 | V6202IR-H00)
			mv /usr/lib/libsns_ar0130_960p.so /usr/lib/libsensor_960p.so
			mv /usr/lib/libsns_ar0130_720p.so /usr/lib/libsensor_720p.so
			[ "$(cat /mnt/flash/productinfo/VinRes.txt 2>/dev/null)" = "1280x960" ] && ln -sf /usr/lib/libsensor_960p.so /usr/lib/libsensor.so || ln -sf /usr/lib/libsensor_720p.so /usr/lib/libsensor.so
			if [ "${hi3518e_branch}" = "single" ];then
				 cp /mnt/flash/Server/default_cfg/CameraInfo_hi3518e_AR0130 /mnt/flash/Server/databak/CameraInfo
			elif [ "${hi3518e_branch}" = "moto" -o "${hi3518e_branch}" = "card" ];then
				 cp /mnt/flash/Server/default_cfg/CameraInfo_hi3518e /mnt/flash/Server/databak/CameraInfo
			else
				 cp /mnt/flash/Server/default_cfg/CameraInfo_AR0130 /mnt/flash/Server/databak/CameraInfo
			fi
			;;
		V6202IR-OV9712 | V6812IR-OV9712)
			cp /mnt/flash/Server/default_cfg/CameraInfo_OV9712 /mnt/flash/Server/databak/CameraInfo
			;;
		V6202IR-9712 | V6812IR-9712)
			SENSOR_NAME="/usr/lib/libsns_ov9712_plus.so"
			if [ "${hi3518e_branch}" = "single" ];then
				 cp /mnt/flash/Server/default_cfg/CameraInfo_hi3518e_OV9712 /mnt/flash/Server/databak/CameraInfo
			elif [ "${hi3518e_branch}" = "moto" -o "${hi3518e_branch}" = "card" ];then
				 cp /mnt/flash/Server/default_cfg/CameraInfo_hi3518e /mnt/flash/Server/databak/CameraInfo
			else
				 cp /mnt/flash/Server/default_cfg/CameraInfo_OV9712 /mnt/flash/Server/databak/CameraInfo
			fi	 
			;;
		V6202IR-9M034 | V6812IR-9M034)
			cp /mnt/flash/Server/default_cfg/CameraInfo_WDR /mnt/flash/Server/databak/CameraInfo
			;;	
		V6202IR-AR0330 | V6812IR-AR0330)
			SENSOR_NAME="/usr/lib/libsns_ar0330_cmos.so"
			cp /mnt/flash/Server/default_cfg/CameraInfo_AR0330 /mnt/flash/Server/databak/CameraInfo
			sensor_pixel=2M
			;;	
		V6202IR-AR0331 | V6812IR-AR0331)
			SENSOR_NAME="/usr/lib/libsns_ar0331_cmos.so"
			sensor_pixel=2M
			;;
		V6202IR-OV4689 | V6812IR-OV4689)
			sensor_pixel=4M
			;;	
		V6202IR-IMX178 | V6812IR-IMX178)
			sensor_pixel=5M
			;;	
		V6202IR-IMX185 | V6812IR-IMX185)
			sensor_pixel=2M
			cp /mnt/flash/Server/default_cfg/sensor.cfg_IMX185 /mnt/flash/Server/databak/sensor.cfg
			;;		
		V6202IR-MN34220 | V6812IR-MN34220)
			sensor_pixel=2M
			;;			
		V6202IR-OV2710 | V6812IR-OV2710)
			cp /mnt/flash/Server/default_cfg/CameraInfo_OV2710 /mnt/flash/Server/databak/CameraInfo
			sensor_pixel=2M
			;;	
		V6202IR-SC1035 | V6812IR-SC1035)
			mv /usr/lib/libsns_sc1035_960p.so /usr/lib/libsensor_960p.so
			mv /usr/lib/libsns_sc1035_720p.so /usr/lib/libsensor_720p.so
			[ "$(cat /mnt/flash/productinfo/VinRes.txt 2>/dev/null)" = "1280x960" ] && ln -sf /usr/lib/libsensor_960p.so /usr/lib/libsensor.so || ln -sf /usr/lib/libsensor_720p.so /usr/lib/libsensor.so
			cp /mnt/flash/Server/default_cfg/CameraInfo_SC1035 /mnt/flash/Server/databak/CameraInfo
			;;		
		V6202IR-SC1020 | V6812IR-SC1020)
			SENSOR_NAME="/usr/lib/libsns_sc1020_720p.so"
			if [ "$(cat /mnt/flash/Server/LINUX/custom.type 2>/dev/null)" = "JSD" ];then
				cp /mnt/flash/Server/default_cfg/CameraInfo_SC1020_JSD /mnt/flash/Server/databak/CameraInfo
			else
				cp /mnt/flash/Server/default_cfg/CameraInfo_SC1020 /mnt/flash/Server/databak/CameraInfo
			fi
			;;		
		V6202IR-BG0701 | V6812IR-BG0701)
			cp /mnt/flash/Server/default_cfg/CameraInfo_SC1020 /mnt/flash/Server/databak/CameraInfo
			;;
		V6202IR-PO4100K | V6812IR-PO4100K)
			cp /mnt/flash/Server/default_cfg/CameraInfo_PO4100K /mnt/flash/Server/databak/CameraInfo
			;;	
		V6202IR-PCD | V6812IR-PCD)
			SENSOR_NAME="/usr/lib/libsns_none.so"
			;;	
	esac
	if [ "$(cat /mnt/flash/databak/hisi_ir.cfg 2>/dev/null)" = "1" ];then
		cp /mnt/flash/Server/default_cfg/CameraInfo_DOME /mnt/flash/Server/databak/CameraInfo
	fi
	wdr_mode=$(cat /mnt/flash/Server/databak/sensor.cfg 2>/dev/null | awk -F= '$1~"wdr"{print $2}'| sed -e 's|[^0-9]||g')
	if [ "${wdr_mode}" != "" -a "${wdr_mode}" != "0" ];then
		cp /mnt/flash/Server/default_cfg/CameraInfo_WDR /mnt/flash/Server/databak/CameraInfo
	fi
	case ${sensor_pixel} in
		2M)
			if [ "$(cat /mnt/flash/Server/databak/sensor.cfg 2>/dev/null | awk -F= '$1~"60fps"{print $2}'| sed -e 's|[^0-9]||g')" = "1" ];then
				cp /mnt/flash/Server/default_cfg/VideoInfo_60fps /mnt/flash/Server/databak/VideoInfo
			fi
			;;
		4M)
			cp /mnt/flash/Server/default_cfg/VideoInfo_4M /mnt/flash/Server/databak/VideoInfo
			;;
		5M)
			cp /mnt/flash/Server/default_cfg/VideoInfo_5M /mnt/flash/Server/databak/VideoInfo
			;;
	esac
	RDdevid=$(awk '$1 == "DEVICEID" {print $2}' /mnt/flash/productinfo/deviceidRecord.cfg 2>/dev/null)
	if [ "${RDdevid}" != "${devid}" ];then
		cp /mnt/flash/Server/databak/VideoInfo /mnt/flash/databak/VideoInfo
		cp /mnt/flash/databak/VideoInfo /mnt/flash/data/VideoInfo
		echo -n "DEVICEID ${devid}" > /mnt/flash/productinfo/deviceidRecord.cfg
	fi
	if [ "$(cat /mnt/flash/Server/mediaserver/ICE.txt 2>/dev/null)" = "IPG" ];then
		cp /mnt/flash/Server/default_cfg/VideoInfo_VLPR /mnt/flash/Server/databak/VideoInfo
		cp /mnt/flash/Server/default_cfg/CameraInfo_VLPR /mnt/flash/Server/databak/CameraInfo
	fi
fi

[ -f ${SENSOR_NAME} ] && mv ${SENSOR_NAME} /usr/lib/libsensor.so
[ -f /usr/lib/libsensor.so ] && SENSOR_TYPE=OK

RUN_APP="/root/watchall"

if [ -z $SENSOR_TYPE ]
then
	echo "====== sensor type is wrong! ======"
	rm -f /mnt/flash/Server/Ztest.sh
	$RUN_APP &
	exit
fi

rm /usr/lib/libsns_*.so
export LD_PRELOAD=/usr/lib/preloadable_libiconv.so

[ -d $APPS_PATH ] || (echo 'mount jffs rom failed.'; exit 1)
if [ "$?" -eq 1 ]; then
	echo "can't run apps, exit autorun script."
else
	sleep 1
	cd $APPS_PATH/driver
	$RUN_SCRIPT
	cd -
	[ $(df /mnt/flash/Server|grep -v Filesystem|awk '{print $1}') = tmpfs ] && rm $APPS_PATH/driver/* -rf
	#/mnt/flash/Server/script/machine_test.sh

	chmod -R 777 $MIDSEV_PATH/*
	cd ${APPS_PATH}/LINUX
	#${MIDSEV_PATH}/sdk_app &
	#sleep 2
	$RUN_APP &
fi
